/*
 * plcsrvthread.h
 *
 *	22.01.07 - SF: first release 
 *	 
 */ 

#ifndef PLCSRVTHREAD_H
#define PLCSRVTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>    
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <arpa/inet.h>
#include <signal.h>




#include <netdb.h>    
#include <PLCaccess.h>
//number of socket accepted by the server
const short MAX_NUM_SOCK=5; ///
static int maskbits[] = {
		posto0,
		posto1,
		posto2,
		posto3,
		posto4,
		posto5,
		posto6,
		posto7,
		posto8,
		posto9,
		posto10,
		posto11,
		posto12,
		posto13,
		posto14,
		posto15
};

class plcsrvthread : public omni_thread, public Tango::LogAdapter
{	
private:
	PLCaccess_ns::PLCaccess *t_PLCaccess;

public:
	plcsrvthread(PLCaccess_ns::PLCaccess *s):Tango::LogAdapter(s),t_PLCaccess(s),errcount(0),cnt(0),cnt2(0),server_started(0){};


	~plcsrvthread() {
	};
	uint16_t plc_swap(uint16_t in);
	uint32_t plc_swapl(uint32_t in);

protected:
	void run(void *);
	int errcount;
	struct timeval _pre, _post;
	char frame2[BUF_LEN];
	Tango::DeviceAttribute arl;
	ssize_t cnt, cnt2;
	int server_started;           

	struct sockaddr_in myname;  
	struct sockaddr_in    addr;    
	char buf[BUF_LEN];
	void Srv_Prepare(void);
	Tango::DevBoolean old_doors[24];
	Tango::DevBoolean old_eme[16];
	void update_old_doors(void);
	void update_eme_buttons(void);

	void write_to_deque(void);
	void write_access_to_deque(void);
	//TOPUP
	void write_topup_to_deque(void);
	//TOPUP
#if 0
	time_t calc_timeval(u_char,u_char,u_char,u_char,u_char,u_char,u_char,u_char);
	int32_t calc_time_ms(u_char,u_char);
#endif

};	/* end class plcsrvthread() */



#endif

/* EOF */
